config/routes.rb
Brimir::Application.routes.draw do

  devise_for :users

  resources :users

  resources :tickets, only: [:index, :show, :update, :new, :create]

  resources :replies, only: [:create, :new]
  get '/attachments/:id/:format' => 'attachments#show'

  root :to => 'tickets#index'

end

app/models/ticket.rb
# Brimir is a helpdesk system to handle email support requests.
# Copyright (C) 2012-2014 Ivaldi http://ivaldi.nl
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class Ticket < ActiveRecord::Base
  include CreateFromUser

  validates_presence_of :user_id

  belongs_to :user
  belongs_to :assignee, class_name: 'User'

  has_many :attachments, as: :attachable, dependent: :destroy

  has_many :replies, dependent: :destroy

  enum status: [:open, :closed, :deleted]
  enum priority: [:unknown, :low, :medium, :high]

  scope :by_status, ->(status) {
    where(status: Ticket.statuses[status.to_sym])
  }

  scope :filter_by_assignee_id, ->(assignee_id) {
    if !assignee_id.nil?
      if assignee_id.to_i == 0
        where(assignee_id: nil)
      else
        where(assignee_id: assignee_id)
      end
    else
      all
    end
  }

  scope :search, ->(term) {
    if !term.nil?
      term = '%' + term.downcase + '%'
      where('LOWER(subject) LIKE ? OR LOWER(content) LIKE ?',
          term, term)
    end
  }

  scope :ordered, -> {
    order(:created_at).reverse_order
  }

  scope :viewable_by, ->(user) {
    if !user.agent?
      where(user_id: user.id)
    elsif !user.incoming_address.nil?
      where(to: user.incoming_address)
    end
  }
end

app/controllers/tickets_controller.rb
# Brimir is a helpdesk system to handle email support requests.
# Copyright (C) 2012-2014 Ivaldi http://ivaldi.nl
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class TicketsController < ApplicationController
  before_filter :authenticate_user!, except: [:create]

  load_and_authorize_resource :ticket, except: [:index, :create]
  skip_authorization_check only: [:create]

  def show
    @agents = User.agents

    @reply = @ticket.replies.new
    @reply.to = @ticket.user.email
  end

  def index
    @agents = User.agents

    params[:status] ||= 'open'

    # TODO: filter status
    @tickets = Ticket.by_status(params[:status])
      .search(params[:q])
      .filter_by_assignee_id(params[:assignee_id])
      .page(params[:page])
      .ordered
      .viewable_by(current_user)

    if @tickets.count > 0
      @tickets.each do |ticket|
        authorize! :index, ticket
      end
    else
      authorize! :index, Ticket
    end
  end

  def update
    respond_to do |format|
      if @ticket.update_attributes(ticket_params)

        # assignee set and not same as user who modifies
        if !@ticket.assignee.nil? && @ticket.assignee.id != current_user.id

          if @ticket.previous_changes.include? :assignee_id
            TicketMailer.notify_assigned(@ticket).deliver

          elsif @ticket.previous_changes.include? :status
            TicketMailer.notify_status_changed(@ticket).deliver

          elsif @ticket.previous_changes.include? :priority
            TicketMailer.notify_priority_changed(@ticket).deliver
          end

        end

        format.html {
          redirect_to @ticket, notice: I18n::translate(:ticket_updated)
        }
        format.js {
          render notice: I18n::translate(:ticket_updated)
        }
        format.json {
          head :no_content
        }
      else
        format.html {
          render action: 'edit'
        }
        format.json {
          render json: @ticket.errors, status: :unprocessable_entity
        }
      end
    end
  end

  def new
    @ticket.user = current_user
  end

  def create
    respond_to do |format|
      format.html do
        @ticket = Ticket.new(ticket_params)

        @ticket.to = current_user.incoming_address unless current_user.nil?

        if @ticket.save!
          TicketMailer.notify_agents(@ticket, @ticket).deliver

          redirect_to ticket_url(@ticket), notice: I18n::translate(:ticket_added)
        else
          render 'new'
        end
      end
      format.json do
        @ticket = TicketMailer.receive(params[:message])
        render json: @ticket, status: :created
      end
      format.js { render }
    end
  end

  private
    def ticket_params
      if !current_user.nil? && current_user.agent?
        params.require(:ticket).permit(
            :from,
            :content,
            :subject,
            :status,
            :assignee_id,
            :priority,
            :message_id)
      else
        params.require(:ticket).permit(
            :from,
            :content,
            :subject,
            :priority)
      end
    end
end

app/views/tickets/_change_assignee_form.html.erb
<div id="change-assignee" class="reveal-modal small" data-reveal>
  <h3><%= t(:change_assignee) %></h3>

  <%= form_for ticket, remote: true, method: :patch do |f| %>
    <p>
      <%= f.select :assignee_id, options_from_collection_for_select(@agents, 'id', 'email', ticket.assignee_id), include_blank: t(:unassigned) %>
    </p>
    <%= f.submit t(:assign), class: 'button' %>
  <% end %>

  <a class="close-reveal-modal">&#215;</a>
</div>

app/views/tickets/_form.html.erb
<%= form_for @ticket, html: { multipart: true } do |f| %>

  <div class="panel mt">
    <h3><%= t(:new_ticket) %></h3>

    <%= f.text_field :from %>

    <%= f.text_field :subject %>

    <%= f.text_area :content, class: 'tinymce' %>
    <%= current_user.signature.to_s.html_safe %>

  </div>
  <p>
    <%= f.submit class: 'button regular radius' %>
  </p>

<% end %>

app/views/tickets/_priority_dropdown.html.erb
<ul id="priorities-<%= ticket.id %>" class="f-dropdown" data-dropdown-content>
  <% Ticket.priorities.keys.each do |value| %>
    <li>
      <%= link_to ticket_path(ticket, ticket: { priority: value }, short: short),
          method: :patch, remote: true do %>
        <span class="priority-<%= value %> fa fa-circle"></span>
        <%= t(value) %>
      <% end %>
    </li>
  <% end %>
</ul>

app/views/tickets/_status_dropdown.html.erb
<ul id="statuses-<%= ticket.id %>" class="f-dropdown" data-dropdown-content>
  <% Ticket.statuses.keys.each do |value| %>
    <li>
      <%= link_to t(value), ticket_path(ticket, ticket: { status: value }),
          method: :patch, remote: true %>
    </li>
  <% end %>
</ul>

app/views/tickets/index.html.erb
<div class="row">
  <div class="large-12 columns">

    <div class="row collapse mt">
      <div class="large-9 columns">
        <% if params[:q].present? %>
          <h2 class="filter-title"><%= t(:tickets_containing) %> '<em><%= params[:q].to_s %></em>'</h2>
        <% else %>
          <h2 class="filter-title"><%= t(:tickets) %></h2>
        <% end %>
      </div>
      <div class="large-3 columns">
        <%= form_tag tickets_path, method: :get do %>
        <div class="row collapse">
          <div class="small-9 columns">
            <%= text_field_tag :q, params[:q] %>
          </div>
          <div class="small-3 columns">
            <%= button_tag t(:search), type: 'submit', class: 'button postfix' %>
          </div>
        </div>
        <% end %>
      </div>
    </div>

    <table class="full zebra">
      <tbody>
        <% @tickets.each do |ticket| %>
          <tr data-ticket-url="<%= ticket_url(ticket) %>">

            <% if can? :update, ticket %>
              <%# DONT FORGET TO UPDATE THE ELSE IF YOU MODIFY THE FOLLOWING HTML %>

              <td>
                <a href="#" data-dropdown="priorities-<%= ticket.id %>">
                  <span class="priority-<%= ticket.priority %> fa fa-circle"></span>
                </a>
                <%= render 'priority_dropdown', ticket: ticket, short: true %>
              </td>
              <td style="white-space:nowrap">
                <%= ticket.user.email %>
              </td>
              <td class="text-secondary table-nowrap">
                <% if !ticket.subject.nil? %>
                  <a href="<%= ticket_url(ticket) %>">
                    <% if ticket.replies.size > 0 %>
                      <span class="radius label" title="<%= ticket.replies.size %> <%= t(:replies) %>"><%= ticket.replies.size %></span>
                    <% end %>
                    <%= ticket.subject %> - <span class="text-secondary"><%= sanitize(ticket.content, tags: [])[0..80] %></span>
                  </a>
                <% else %>
                  <%= link_to ticket do %>
                    <em>(<%= t(:no_subject) %>)</em>
                  <% end %>
                <% end %>
              </td>
              <td>
                <a href="#" data-dropdown="statuses-<%= ticket.id %>">
                  <%= t(ticket.status) %>
                </a>
                <%= render 'status_dropdown', ticket: ticket %>
              </td>
              <td>
                <% if ticket.assignee %>
                  <a data-assignee-id="<%= ticket.assignee.id %>" href="#"><i class="fa fa-user"></i> <%= ticket.assignee.email %></a>
                <% else %>
                  <a data-assignee-id="" href="#"><em><%= t(:unassigned) %></em></a>
                <% end %>
              </td>

            <% else %>
              <%# DONT FORGET TO UPDATE THE IF ABOVE IF YOU MODIFY THE FOLLOWING HTML %>

              <td><span class="priority-<%= ticket.priority %> fa fa-circle" title="<%= t(:priority) %> <%= ticket.priority %>"></span></td>
              <td style="white-space:nowrap">
                <%= ticket.user.email %>
              </td>
              <td class="text-secondary table-nowrap">
                <% if !ticket.subject.nil? %>
                  <a href="<%= ticket_url(ticket) %>">
                    <% if ticket.replies.size > 0 %>
                      <span class="radius label" title="<%= ticket.replies.size %> <%= t(:replies) %>"><%= ticket.replies.size %></span>
                    <% end %>
                    <%= ticket.subject %> - <span class="text-secondary"><%= sanitize(ticket.content, tags: [])[0..80] %></span>
                  </a>
                <% else %>
                  <%= link_to ticket do %>
                    <em>(<%= t(:no_subject) %>)</em>
                  <% end %>
                <% end %>
              </td>
              <td>
                <span class="status-<%= ticket.status %>"></span>
              </td>
              <td>
                <% if ticket.assignee %>
                  <i class="fa fa-user"></i> <%= ticket.assignee.email %>
                <% else %>
                  <em><%= t(:unassigned) %></em>
                <% end %>
              </td>

            <% end %>

            <td class="nowrap text-right text-secondary">
              <%= l ticket.created_at, format: :short %>
            </td>
          </tr>
        <% end %>

        <% if @tickets.empty? %>
          <tr>
            <td colspan="100%"><%= t(:no_tickets_found) %></td>
          </tr>
        <% end %>

      </tbody>
    </table>

    <div class="pagination-centered">
      <%= will_paginate @tickets %>
    </div>
  </div>
</div>

<%= render 'change_assignee_form', { ticket: Ticket.new } %>

app/views/tickets/new.html.erb
<div class="row">
  <div class="large-9 columns">

    <%= render 'form' %>

  </div>
</div>

app/views/tickets/show.html.erb
<div class="row mt">
  <div class="large-12 columns">
    <h2>
      <%= !@ticket.subject.nil? ? @ticket.subject : '<em>(' + t(:no_subject) + ')</em>'.html_safe %>
    </h2>
    <h5 class="subheader text-secondary">
      <%= t(:ticket_by_at, email: @ticket.user.email, at: l(@ticket.created_at, format: :long)) %>
    </h5>
  </div>
</div>

<div class="row mt">
  <div class="large-9 columns">

    <% if @ticket.content.nil? %>
      (<%= t(:no_content) %>)
    <% else %>

      <div class="output">
        <% if @ticket.content_type == 'html' %>
          <% content = @ticket.content.html_safe %>
        <% elsif @ticket.content_type == 'text' %>
          <% content = @ticket.content.gsub("\n", '<br />') %>
        <% else %>
          <% content = @ticket.content %>
        <% end %>

        <%# only allow these tags and attributes %>
        <%= sanitize content, tags: %w(a b br code div em i img li ol p pre table td tfoot thead tr span strong ul), attributes: %w(src href) %>
      </div>
    <% end %>

    <% if @ticket.attachments.size > 0 %>
      <hr />
      <ul class="block-grid three-up attachments">
        <%= render @ticket.attachments %>
      </ul>
    <% end %>
  </div>

  <div class="large-3 columns">
    <dl>

      <% if can? :update, @ticket %>

        <dt><%= t(:status) %>:</dt>
        <dd>
          <a href="#" data-dropdown="statuses-<%= @ticket.id %>">
            <%= t(@ticket.status) %>
          </a>
          <%= render 'status_dropdown', ticket: @ticket %>
        </dd>
        <dt><%= t(:priority) %>:</dt>
        <dd>
          <a href="#" data-dropdown="priorities-<%= @ticket.id %>">
            <span class="priority-<%= @ticket.priority %> fa fa-circle"></span> <%= t(@ticket.priority) %>
          </a>
          <%= render 'priority_dropdown', ticket: @ticket, short: false %>
        </dd>
        <dt><%= t(:assignee) %>:</dt>
        <dd>
          <a href="#" data-reveal-id="change-assignee">
          <% if !@ticket.assignee %>
            <%= t(:unassigned) %>
          <% else %>
            <%= @ticket.assignee.email %>
          <% end %>
          </a>
        </dd>

      <% else %>

        <dt><%= t(:status) %>:<dt>
        <dd><%= t(@ticket.status) %></dd>
        <dt><%= t(:priority) %>:</dt>
        <dd><%= t(@ticket.priority) %></dd>
        <dt><%= t(:priority) %>:</dt>
        <dd>
          <% if !@ticket.assignee %>
            <em><%= t(:nobody) %></em>
          <% else %>
            <%= @ticket.assignee.email %>
          <% end %>
        </dd>

      <% end %>

    </dl>
  </div>

</div>

<div class="row">
  <div class="large-9 columns">
    <% if @ticket.replies.size > 1 %>
      <h3 class="mt"><%= t(:num_replies, count: (@ticket.replies.size - 1)) %></h3>
      <dl class="accordion" data-accordion>

        <% count = 0 %>
        <% @ticket.replies.chronologically.each do |reply| %>

            <%# minus 2, because @reply is a new ticket that is counted as well... %>
            <% if @ticket.replies.size - 2 == count %>
              <% div_class = 'content active' %>
            <% else %>
              <% div_class = 'content' %>
            <% end %>

          <dd>
            <a class="title" href="#reply-<%=reply.id%>">
              <h5><%= reply.user.email %> <small class="pull-right"><%= l reply.created_at, format: :short %></small></h5>
            </a>
            <div id="reply-<%=reply.id%>" class="<%= div_class %>">

              <% if reply.content_type == 'html' %>
                <% content = reply.content.html_safe %>
              <% elsif reply.content_type == 'text' %>
                <% content = reply.content.gsub("\n", '<br />') %>
              <% else %>
                <% content = reply.content %>
              <% end %>

              <%= sanitize content, tags: %w(a b br code div em i img li ol p pre table td tfoot thead tr span strong ul), attributes: %w(src href) %>
              <% if reply.attachments.size > 0 %>
                <hr />
                <ul class="block-grid three-up attachments">
                  <%= render reply.attachments %>
                </ul>
              <% end %>
            </div>
          </dd>

          <% count += 1 %>

        <% end %>

      </dl>
    <% end %>  
    <% if can? :create, @reply %>
      <%= render 'replies/form' %>
    <% end %>
  </div>
</div>

<%= render 'change_assignee_form', { ticket: @ticket } %>

app/views/tickets/update.js.erb
<% if !params[:ticket][:status].blank? %>
  jQuery('[data-dropdown="statuses-<%= @ticket.id %>"]').text('<%= j(t(@ticket.status)) %>');

<% elsif !params[:ticket][:priority].blank? %>
  jQuery('[data-dropdown="priorities-<%= @ticket.id %>"]')
      .empty()
      .append('<span class="priority-<%= @ticket.priority %> fa fa-circle"></span> ' +
          '<%= j(t(@ticket.priority)) unless params[:short] == 'true' %>');

<% else %>
  window.location.reload();
<% end %>

<%# close all dropdowns %>
var dropdowns = jQuery('.f-dropdown');
dropdowns.foundation('dropdown', 'close', dropdowns);